var ua = navigator.userAgent;
var map, circleS, namazu, home;
var zoomlevel;			// GoogleMaps ズームレベル
var logtime = 0;		// sne.log の最終更新日時
var err_count = 0;		// 接続エラー試行回数
var end_count = 0;		// 地震終了後の復帰用カウンタ
var stop = 0;			// 再生時、停止ボタンが押されたか
var time_checked = 0;	// 時刻合わせ
var intID;				// タイマーID
var filter_level;		// 「緊急地震警報」とする最低予想震度
var min_level;			// 「地震が発生～」読み上げする最低マグニチュード
var min_mag;			// 「地震が発生～」読み上げする最低震度
var big_level;			// 「大きな揺れに～」読み上げする最低震度
var level_passed = 0;	// その最低震度を超えているか
var min_passed = 0;		// その最低震度を超えているか
var sound = new Array();		// HTML5 Audio用配列
var sound_pri = new Array();	// 再生優先順位用配列
var sound_count = 0;			// sound配列用カウンタ
var win = new Array();
var win_count = 0;
var shift_key = false;
var ban_width;
var testID;
var last_eId;
try{
	if(eId) last_eId = eId;
} catch(e){}
if(!!(document.createElement('audio').canPlayType)){		// 接続エラー用の音声ファイル先読み
	if(ua.match(/Firefox/) || ua.match(/Chrome\/([\.\d]+)/) || ua.match(/Opera[\/\s](\d\.\d+)/)){
		var err_network = new Audio(__OGG_DIR + "err_network.ogg");
		err_network.load();
		var chime = new Audio(__OGG_DIR + "chime2.ogg");
		chime.load();
	} else {
		var err_network = new Audio(__WAV_DIR + "err_network.wav");
		err_network.load();
		var chime = new Audio(__WAV_DIR + "chime2.wav");
		chime.load();
	}
}

function replaceAll(expression, org, dest){		// 文字列置換
	return expression.split(org).join(dest);
}

function get_zoom(distance){	// GoogleMaps ズームレベル取得
	var zoomlevel;
	if(distance >= 1500){
		zoomlevel = 5;
	} else if(distance >= 600){
		zoomlevel = 6;
	} else if(distance >= 300){
		zoomlevel = 7;
	} else if(distance >= 150){
		zoomlevel = 8;
	} else if(distance >= 75){
		zoomlevel = 9;
	} else {
		zoomlevel = 10;
	}
	return zoomlevel;
}

function get_levelColor(val){		// 予想震度(level)による色変更
	var elmH;
	var tlevel;
	if(val == undefined){
		tlevel = level;
	} else {
		tlevel = Number(val);
	}
	if(tlevel >= 7){
		elmH = 0;
	} else if(tlevel <= 1){
		elmH = 220;
	} else {
		elmH = Math.round(9.55 * Math.pow(0.8 * (7 - Number(tlevel)),2));
	}

	var elmR;
	var elmG;
	var elmB;
	var	t1 = 255;
	var	t2 = 0;
	var	t3 = elmH % 60;
	var	t3 = (t1 - t2) * t3 / 60;

	if(elmH < 60) {
		elmR = t1;  elmB = t2;  elmG = t2 + t3;
	} else if(elmH < 120) {
		elmG = t1;  elmB = t2;  elmR = t1 - t3;
	} else if(elmH < 180) {
		elmG = t1;  elmR = t2;  elmB = t2 + t3;
	} else if(elmH < 240) {
		elmB = t1;  elmR = t2;  elmG = t1 - t3;
	} else if(elmH < 300) {
		elmB = t1;  elmG = t2;  elmR = t2 + t3;
	} else if(elmH < 360) {
		elmR = t1	;  elmG = t2;  elmB = t1 - t3;
	} else {
		elmR = 0;   elmG = 0;   elmB = 0;
	}

	elmR = Math.floor(elmR).toString(16);
	elmG = Math.floor(elmG).toString(16);
	elmB = Math.floor(elmB).toString(16);
	if (elmR.length == 1)	elmR = "0" + elmR;
	if (elmG.length == 1)	elmG = "0" + elmG;
	if (elmB.length == 1)	elmB = "0" + elmB;

	return '#' + elmR + elmG + elmB;
}

function epi_change(){			// テストモード リスト表示時、震源地変更
	if(intID){
		clearTimeout(intID);
	}
	stop = 1;
	$("#notice").css("color","#fff");
	$("#btToggle").text("再生");

	var str = $('#eID_sel option:selected').val();
	var arrVal = str.split(",");
	var ll = arrVal[1].split("/");
//	alert(arrVal[1]);
	epiPos = new google.maps.LatLng(Number(ll[0]),Number(ll[1]));
	namazu.position = epiPos;
	namazu.setMap(map);

	var ll2 = arrVal[4].split("/");
	homePos = new google.maps.LatLng(Number(ll2[0]),Number(ll2[1]));
	home.position = homePos;
	home.setMap(map);

	distance = epiPos.distanceFrom(homePos);
	centerPos = new google.maps.LatLng((Number(ll[0]) + Number(ll2[0])) / 2, (Number(ll[1]) + Number(ll2[1])) / 2);
	map.panTo(centerPos);
//	map.setCenter(centerPos);

	zoomlevel = get_zoom(distance);
	map.setZoom(zoomlevel);

	circleS.center = epiPos;
	circleS.setRadius(distance * 1000);
	circleS.setMap(map);

	$("#situ").html("暫定Mj:<span class='num small' id='mag'>" + sprintf("%2.1f",arrVal[2]) + 
		"</span>　深さ:<span class='num small' id='depth'>" + arrVal[3] + 
		"</span>km　予想震度：<span class='num small' id='level'>" + sprintf("%2.1f",arrVal[5]) + "</span>\n");
//	$("#situ").show();
	level = arrVal[5];
	$("#situ").css("backgroundColor",get_levelColor());

	var cOptions = {
		strokeColor: get_levelColor()
	};
	circleS.setOptions(cOptions);

	var label = $('#eID_sel option:selected').parents("optgroup").attr("label");
	$("#notice").html("<br />過去の地震<br /><span class='num'>" + label + " " + $('#eID_sel option:selected').text() + "</span>");
	$("#notice").css("fontSize","40px");
	$("#notice").show();
	document.getElementById("notice").style.opacity = "1.0";
}
function check_window(cnt){
	if(!!win[cnt] && !win[cnt].closed){
//		if(chime.ended){
//			chime.pause();
//			chime.currentTime = 0;
//		}
		setTimeout("check_window(" + cnt + ")",1000);
	} else {
		$("#btToggle").attr("title","再生");
		$("#btToggle").attr("src", __IMG_DIR + "b_play_m.png");
	}
}

function do_test(){					// テスト再生、停止
	if($("#btToggle").attr("title") == "再生"){
		if(shift_key){
			if(window.confirm("約80秒後に再生を開始します")){
				testID = setTimeout("go_test()",80000);
			} else {
				alert("再生をキャンセルしました");
			}
		} else {
			go_test();
		}
	} else {
		if(!!win[win_count-1]){
			win[win_count-1].close();
		}
		$("#btToggle").attr("title","再生");
		$("#btToggle").attr("src", __IMG_DIR + "b_play_m.png");
	}
}

function go_test(){
	var str = $('#eID_sel option:selected').val();
	var arrVal = str.split(",");
	var str = "?test=1&dotest=1&eId=" + arrVal[0];
	var mWinName = "win_t_" + arrVal[0];
	if(Number(arrVal[5]) >= filter_level){
//	if(true){
//			chime.currentTime = 0;
		chime.play();
		if(m_max == 1){
			var mOption = "top=" + screen.availTop + ",left=" + screen.availLeft + ",width=" + screen.availWidth + ",height=" + screen.availHeight;
		} else {
			var mOption = "top=" + screen.availTop + ",left=" + screen.availLeft + ",width=" + m_width + ",height=" + m_height;
		}
	} else {
		var top = Math.floor((screen.availHeight - s_height) / 2); 
		var left = Math.floor((screen.availWidth - s_width) / 2); 
		var mOption = "left=" + left + ",top=" + top + ",width=" + s_width + ",height=" + s_height;
	}
	win[win_count] = window.open("pop_up.php" + str, mWinName, mOption);
	$("#btToggle").attr("title","停止");
	$("#btToggle").attr("src", __IMG_DIR + "b_stop_m.png");
	setTimeout("check_window(" + win_count + ")",4000);
	win[win_count].focus();
	win_count++;
}

function view_situation(){			// 画面下段の状況表示
	$("#situ").css("backgroundColor",get_levelColor());						// 予想震度に依る状況表示背景色変更
	if(last == 1){
		var str =  "　<span class='ver'>(最終報)</span><span id='last' style='display:none'></span>";
	} else {
		var str = "　<span class='ver'>(第" + ver + "報)</span>";
	}
	$("#situ").html("暫定Mj:<span class='num small' id='mag'>" + sprintf("%2.1f",mag) + 
		"</span>　深さ:<span class='num small' id='depth'>" + sprintf("%d",depth) + 
		"</span>km　予想震度：<span class='num small' id='level'>" + sprintf("%2.1f",level) + "</span>" + str);
//	$("#situ").show();
}

function resize_window(){						// ウインドウリサイズイベント
	var width, height;
	if(window.innerWidth){
		width = window.innerWidth;
		height = window.innerHeight;
	}else if(document.documentElement && document.documentElement.clientWidth){
		width = document.documentElement.clientWidth;
		height = document.documentElement.clientHeight;
	}else if(document.body && document.body.clientWidth){
		width = document.body.clientWidth;
		height = document.body.clientHeight;
	}
	$("#map_canvas").css("width",width + "px");
	$("#map_canvas").css("height",(height - 4) + "px");
	$("#notice").css("top",(height * 0.28) + "px");
	if(map){
		var handle = google.maps.event.addListener(map, 'bounds_changed', function(){	// サイズ(表示領域)変更イベント
			map.setCenter(centerPos);													// 中心にして
			google.maps.event.removeListener(handle);									// 即開放
		}); 
	}
	if($(".sponsor").length > 0){														// 広告表示する場合
		if(window.innerWidth){
			ban_width = window.innerWidth / 6;
		} else if(document.documentElement && document.documentElement.clientWidth){
			ban_width = document.documentElement.clientWidth / 6;
		} else if(document.body && document.body.clientWidth){
			ban_width = document.body.clientWidth / 6;
		}
		if(ban_width > 200)	ban_width = 200;
		make_dock();
	}
}

function set_sound(source){								// 音源ファイル代入と再生
	if(ua.match(/MSIE (\d\.\d+)/)){
		$("#sound").attr("src",source);
	} else {
		if(ua.match(/Firefox/) || ua.match(/Chrome\/([\.\d]+)/) || ua.match(/Opera[\/\s](\d\.\d+)/)){
			sound[sound_count] = new Audio(source.replace(__MP3_DIR,__OGG_DIR).replace(/\.mp3$/,".ogg"));
		} else {
			sound[sound_count] = new Audio(source.replace(__MP3_DIR,__WAV_DIR).replace(/\.mp3$/,".wav"));
		}
		sound[sound_count].play();
		sound_count++;
	}
}
function test_popup(){
	alert("2秒後に " + s_width + " x " + s_height + " でポップアップウィンドウを開き、その10秒後にウィンドウを閉じます");
	setTimeout("popup()",2000);
}

function popup(){
	var url = "pop_up.php?pop=1&eId=" + last_eId;
	var mWinName = "win_" + last_eId;
	var top = Math.floor((screen.availHeight - s_height) / 2); 
	var left = Math.floor((screen.availWidth - s_width) / 2); 
	var mOption = "width=" + s_width + ",height=" + s_height + ",top=" + top + ",left=" + left;
	win[win_count] = window.open(url, mWinName, mOption);
	win_count++;
	setTimeout("win_find()",10000);
}

function win_find(){
	if(win_count > 0){
		for(var i=win_count-1;i>=0;i--){
			try{
//				if(win[i].document.title.indexOf(last_eId) > 0){
				if(win[i].name == "win_" + last_eId){
					win[i].close();
				}
			} catch(e) {}
		}
	}
}

$(function(){
	if(eCase == 8){					// 再生時は
		get_tValiable(0);			// 変数読み込み
	}
	main();							// メイン処理へ
});

function keydown_check(e){
	if(e.keyCode == 16)
	shift_key = true;
}
function keyup_check(e){
	if(e.keyCode == 16)
	shift_key = false;
}

function main(){					// onloadイベントのメイン処理
	document.onkeydown = keydown_check;
	document.onkeyup = keyup_check;

	resize_window();
//	$(".sponsor").width(250);

	zoomlevel = get_zoom(distance);

	var mapOptions;
	mapOptions = {
		disableDoubleClickZoom : false,
		scrollwheel: true,
		zoom : zoomlevel,
		center : centerPos,
		navigationControl: true,
		navigationControlOptions : {
			position : google.maps.ControlPosition.TOP_RIGHT
		},
		mapTypeControl: false,
		scaleControl: false,
		streetViewControl : false,
		mapTypeId: google.maps.MapTypeId.TERRAIN
	};
	map = new google.maps.Map(document.getElementById("map_canvas"), mapOptions);

	var color = get_levelColor();

	var cOpt1 = {
		center : epiPos,
//		fillColor: color,
		fillColor: "#000000",				// 塗りつぶしは黒
//		fillColor: "#ffffff",				// 塗りつぶしは白
		fillOpacity: 0.2,
		map: map,
		radius: 0,
		strokeColor: color,					// 枠のみ色づけ
		strokeOpacity: 0.8,
		strokeWeight: 4,
		clickable : false
	};
	circleS = new google.maps.Circle(cOpt1);
	circleS.center = epiPos;
	circleS.setMap(map);

	namazu = new google.maps.Marker({
		icon: new google.maps.MarkerImage(__IMG_DIR + "ePoint.gif", 
			new google.maps.Size(32,32), 
			new google.maps.Point(0,0),  
			new google.maps.Point(16,16)),
		map: map,
		position: epiPos,
		clickable : false
	});
	home = new google.maps.Marker({
		icon: new google.maps.MarkerImage(__IMG_DIR + "home32.gif", 
			new google.maps.Size(32,32), 
			new google.maps.Point(0,0),  
			new google.maps.Point(16,16)),
		map: map,
		position: homePos,
		clickable : false
	});
/*
	var image = "http://labs.google.com/ridefinder/images/mm_20_blue.png";
	var pPos = new Array();
	var cOpt = new Array();
	var nied_m = new Array();
	for(var i=0;i<nied_p.length;i++){
		pPos[i] = new google.maps.LatLng(nied_p[i][0],nied_p[i][1]);
*/
/*
		cOpt[i] = {
			center : pPos[i],
			fillColor: "#0000ff",
			fillOpacity: 0.5,
			strokeColor: "#000000",
			strokeOpacity: 0.8,
			strokeWeight: 1,
			map: map,
			radius: 10000,
			clickable : false
		};
		nied_c[i] = new google.maps.Circle(cOpt[i]);
		nied_c[i].center = pPos[i];
		nied_c[i].setMap(map);
		*/
/*
		nied_m[i] = new google.maps.Marker({
			position: pPos[i], 
			map: map,
			icon: image
		});
	}
*/
/*
	var niedBounds = new google.maps.LatLngBounds(
		new google.maps.LatLng(29.95,129.00),
		new google.maps.LatLng(45.95,146.00)
	);
	niedMap = new google.maps.GroundOverlay(
//		__IMG_DIR + "nied_map.png",
		"/sne/nied/ND20110711104400/20110711104522.png",
		niedBounds);
	niedMap.setMap(map);
*/
/*
	var niedBounds = new google.maps.LatLngBounds(
		new google.maps.LatLng(29.90,129.00),
		new google.maps.LatLng(45.75,146.00)
	);
	niedMap = new ProjectedOverlay(map, __IMG_DIR + "nied_map.png", niedBounds, {'percentOpacity': 80});
*/
	$(window).bind("resize", resize_window);

	($.cookie('filter_level')) ? filter_level = Number($.cookie('filter_level')) : filter_level = 1.5;
	($.cookie('min_level')) ? min_level = Number($.cookie('min_level')) : min_level = 0.5;
	($.cookie('min_mag')) ? min_mag = Number($.cookie('min_mag')) : min_mag = 6.0;
	($.cookie('big_level')) ? big_level = Number($.cookie('big_level')) : big_level = 4.0;
	if($.cookie('s_width')) s_width = Number($.cookie('s_width'));
	if($.cookie('s_height')) s_height = Number($.cookie('s_height'));
	if($.cookie('m_width')) m_width = Number($.cookie('m_width'));
	if($.cookie('m_height')) m_height = Number($.cookie('m_height'));
	if($.cookie('m_max')) m_max = Number($.cookie('m_max'));

	$("#pref").bind("click",function(){
		if($(".notify-bar-close").length){
			$(".notify-bar-close").click();
		} else {
			set_sound(__MP3_DIR + "pipi.mp3");
			$.get("pref.php",
				null,
				function(data){
					$.notifyBar({
						html: data,
						close: true,
						delay: 60000,
						animationSpeed: "normal"
					});
					if($("#place").length){
						$("#place").load("get_place.php");
					}
				}
			);
		}
	});

	if(eCase >= 70){				// ログ関連のエラー
		switch(eCase){
			case 98:
				$("#notice").css("color","#ff3");
				$("#notice").css("fontSize","40px");
				$("#notice").html("ログファイルに<br />地震の履歴はありません");
				$("#back").hide();
				setTimeout("log_check()",1000);
				break;

			case 99:
				$("#notice").css("color","#f22");
				$("#notice").css("fontSize","40px");
				$("#notice").html("サーバー上に<br />ログファイルが見つかりません");
				$("#back").hide();
				$("#filter").hide();
				break;
		}

	} else {
		$("#eID_sel").jQselectable({
			callback: function(){
				epi_change();
			}
		});
		jQuery.each($("#eID_sel_mat a"),function(){
			$(this).css("color",get_levelColor($(this).attr("name").split(",")[5]));
		});
		try{										// SNE関連エラー
			if(sne_exec == 0){
				$("#warning").html("サーバー上で<abbr title='SignalNow Express'>SNE</abbr>が起動していません");
			} else if(sne_connect == 0){
				$("#warning").html("サーバー上の<abbr title='SignalNow Express'>SNE</abbr>が接続されていません");
			}
		} catch(e){}
		var eDate = new Date(etime * 1000);
		$("#notice").css("fontSize","40px");
		$("#notice").css("color",get_levelColor());
		$("#notice").css("opacity","1");
		$("#notice").html("直近の地震<br /><span class='num'>" + get_timestring(eDate) + "</span>");
		view_situation();
//		$("#debug").text(last_eId);
		setTimeout("log_check()",1000);
	}
/*
	if(window.webkitNotifications){
		$("#desktop").show();
		var $request = $("#desktop");
		if(window.webkitNotifications.checkPermission() == 0){
				$request.html('デスクトップ通知は許可済みです');
				setTimeout("test_desktop()",80000);
		}
		//通知の許可
		$request.click(function(e) {
				e.preventDefault();
				window.webkitNotifications.requestPermission(function(){
						if(window.webkitNotifications.checkPermission() == 0){
								$request.html('デスクトップ通知は許可済みです');
						}
						//(cb) && cb(window.webkitNotifications.checkPermission() == 0);
				});
		});
	}
*/
}
function make_dock(){
	if($(".jqDock").length){
		$('#ban').hide();
		$('#ban').css("left",0);
		$('#ban').jqDock('destroy');
	}
	var onDockSleep = function(){
		var dock = $('.jqDock', this);
		dock.animate({left:-1*(dock.width()),opacity:0},400);
		$('#ban').animate({left:-1*$('#ban').width() - 10},400);
		$(this).one('mousemove', function(){
			$('#ban').stop().animate({left:0},200);
			dock.stop().animate({opacity:1,left:0},300);
			$(this).trigger('docknudge');
			return false;
		});
		return false;
	}
	var opts = {
		align:'left',
		size:ban_width,
		distance:50,
		idle:2000,
		onSleep: onDockSleep
	};
	$('#ban').jqDock(opts);
}

function test_desktop(){
	var notity = window.webkitNotifications;
	var img_url = "/sne/images/namazu.gif";
	var popup = notity.createNotification(img_url,"タイトル","テキスト");
	popup.show();
}

function get_timestring(date){					// 日時文字列取得
	var str = date.getFullYear() + "-" + 
		sprintf("%02d",date.getMonth() + 1) + "-" + 
		sprintf("%02d",date.getDate()) + "   " + 
		sprintf("%02d",date.getHours()) + ":" + 
		sprintf("%02d",date.getMinutes()) + ":" + 
		sprintf("%02d",date.getSeconds());
	return str;
}

function save_cookie(){															// 各種設定保存
	if($("#btCookie").text() == "閉じる"){
		$(".notify-bar-close").click();
	} else {
		if(isNaN($("#filter_level").val())){
			alert($("#filter_level").val() + "は数値として評価できません");
		} else if(isNaN($("#min_level").val())){
			alert($("#min_level").val() + "は数値として評価できません");
		} else if(isNaN($("#min_mag").val())){
			alert($("#min_mag").val() + "は数値として評価できません");
		} else if(isNaN($("#big_level").val())){
			alert($("#big_level").val() + "は数値として評価できません");
		} else if(isNaN($("#s_width").val())){
			alert($("#s_width").val() + "は数値として評価できません");
		} else if(isNaN($("#s_height").val())){
			alert($("#s_height").val() + "は数値として評価できません");
		} else if(!$("#m_max").attr("checked") && isNaN($("#m_width").val())){
				alert($("#m_width").val() + "は数値として評価できません");
		} else if(!$("#m_max").attr("checked") && isNaN($("#m_height").val())){
				alert($("#m_height").val() + "は数値として評価できません");
		} else {
			filter_level = Number($("#filter_level").val());
			$.cookie('filter_level', filter_level, { path: __SELF_DIR, expires:365});
			min_level = Number($("#min_level").val());
			$.cookie('min_level', min_level, { path: __SELF_DIR, expires:365});
			min_mag = Number($("#min_mag").val());
			$.cookie('min_mag', min_mag, { path: __SELF_DIR, expires:365});
			big_level = Number($("#big_level").val());
			$.cookie('big_level', big_level, { path: __SELF_DIR, expires:365});
			s_width = Number($("#s_width").val());
			$.cookie('s_width', s_width, { path: __SELF_DIR, expires:365});
			s_height = Number($("#s_height").val());
			$.cookie('s_height', s_height, { path: __SELF_DIR, expires:365});
			if($("#m_max").attr("checked")){
				m_max = 1;
				$.cookie('m_max', m_max, { path: __SELF_DIR, expires:365});
			} else {
				m_max = 0;
				$.cookie('m_max', m_max, { path: __SELF_DIR, expires:365});
				m_width = Number($("#m_width").val());
				$.cookie('m_width', m_width, { path: __SELF_DIR, expires:365});
				m_height = Number($("#m_height").val());
				$.cookie('m_height', m_height, { path: __SELF_DIR, expires:365});
			}
			$("<p>設定を保存しました</p>").insertBefore("#btCookie");
			$("#btCookie").text("閉じる");
		}
	}
}

function get_dValiable(){						// 速報時に続報データを取得
	if($("#cancel").length){					// キャンセル報
		location.href = __SELF_DIR;				// データ読み直し(現在の地震表記を消す)
	} else {
		ver = Number($("#d_ver").text());
		etime = Number($("#d_etime").text());
		mag = Number($("#d_mag").text());
		level = Number($("#d_level").text());
		depth = $("#d_depth").text();
		stime = Number($("#d_stime").text());

		var lat1 = epiPos.lat();
		var lng1 = epiPos.lng();

		if(Math.abs(lat1 - Number($("#d_eLat").text())) >= 0.09 || Math.abs(lng1 - Number($("#d_eLng").text())) >= 0.09){	// 震央位置に変更あったら
			epiPos = new google.maps.LatLng(Number($("#d_eLat").text()),Number($("#d_eLng").text()));
			namazu.position = epiPos;
			namazu.setMap(map);

			homePos = new google.maps.LatLng(Number($("#d_hLat").text()),Number($("#d_hLng").text()));
			home.position = homePos;
			home.setMap(map);

			distance = epiPos.distanceFrom(homePos);
			centerPos = new google.maps.LatLng((Number($("#d_eLat").text()) + homePos.lat())/2,(Number($("#d_eLng").text()) + homePos.lng())/2);
			map.panTo(centerPos);
//			map.setCenter(centerPos);
			zoomlevel = get_zoom(distance);
			map.setZoom(zoomlevel);
			circleS.center = epiPos;
			circleS.setMap(map);
			circleS.setRadius(0);
		}

		if($("#last").length){
			last = 1;
		}
		var eDate = new Date(etime * 1000);
		$("#notice").html("地震発生<br /><span class='num'>" + get_timestring(eDate) + "</span>");
		$("#notice").css("color",get_levelColor());
		$("#situ").css("backgroundColor",get_levelColor());						// 予想震度にる状況表示背景色変更

		$("#data").remove();
		$("#situ").html($("#store").html());
		$("#store").html("");
		end_count = 1;
		if(last == 1 && level_passed == 0 && min_passed == 0){
			location.href = __SELF_DIR;
		}
	}
}

function log_check(){											// sne.logチェック
	if(eCase != 8){
		if(time_checked == 0){
			var $ntp = $.ajax({
				url: __SERVER_URL + __SELF_DIR + "ntp.php",
				dataType: "text",
				cache: false,
				timeout: 500,
				success: function(data){
					var nDate = new Date();
					if(Math.abs(Number(data) - nDate.getTime() / 1000) >= 3.5){
//						$("#debug").text(data + ":" + nDate.getTime() / 1000);
						$("#caution").html("PCの時間をJSTに合わせて下さい");
						$("#caution").show();
					}
					time_checked = 1;
				},
				error:function(XMLHttpRequest, textStatus, errorThrown){
					if(textStatus == "timeout"){
						$ntp.abort();
					}
				}
			});
		}
		var tDate = new Date();
		var tStr = get_timestring(tDate);
		now = Math.round(tDate.getTime() / 1000);
		$("#date").html(tStr.replace(" ","<br />　　"));
	}
	try{										// SNE関連エラー
		if($("#d_sne_exec").length || sne_exec == 0){
			$("#warning").html("サーバー上で<abbr title='SignalNow Express'>SNE</abbr>が起動していません");
		} else if($("#d_sne_connect").length || sne_connect == 0){
			$("#warning").html("サーバー上の<abbr title='SignalNow Express'>SNE</abbr>が接続されていません");
		} else if(err_count == 0){
			$("#warning").html("");
		}
	} catch(e){}
	var $gettime = $.ajax({
		url: __SERVER_URL + __SELF_DIR + "get_filetime.php",
		cache: false,
		timeout: 500,
		success: function(data){
			if(data){
//				$("#debug").text(end_count);
				if(end_count >= 300){									// 何もなく5分経過したら
					location.href = __SELF_DIR;							// データ読み直し(現在の地震表記を消す)
				} else if(logtime == 0){								// 初回読み込み
					logtime = data;										// ログ更新時間を保存
					view_situation();
				} else if (logtime < data){								// ログが更新されたら
					var temptime = data;
					var $getdata = $.ajax({
						url: __SERVER_URL + __SELF_DIR + "get_data.php",
						cache: false,
						timeout: 500,
						success: function(data){
							logtime = temptime;
							$("#store").html(data);
							if($("#d_eId").length){
								var server = false;
								if($("#d_eId").text() != last_eId){
									last_eId = $("#d_eId").text();
									end_count = 1;
									level_passed = 0;
									min_passed = 0;
									if(win_count > 0){
										for(var i=win_count-1;i>=0;i--){
											try{
												if(win[i].name.indexOf("_t_") > 0){
													win[i].close();
												}
											} catch(e) {}
										}
									}
									try{
										clearTimeout(testID);
									} catch(e) {}
									if(level_passed == 0 && Number($("#d_level").text()) >= filter_level){
										level_passed = 1;
										min_passed = 1;
//										if(chime.ended){
//											chime.pause();
//											chime.currentTime = 0;
//										}
//										chime.currentTime = 0;
										chime.play();
										var url = "pop_up.php?eId=" + last_eId;
										var mWinName = "win_" + last_eId;
										if(m_max == 1){
											var mOption = "top=" + screen.availTop + ",left=" + screen.availLeft + ",width=" + screen.availWidth + ",height=" + screen.availHeight;
										} else {
											var mOption = "top=" + screen.availTop + ",left=" + screen.availLeft + ",width=" + m_width + ",height=" + m_height;
										}
										win[win_count] = window.open(url, mWinName, mOption);
										win_count++;
									} else if(min_passed == 0 && (Number($("#d_level").text()) >= min_level || Number($("#d_mag").text()) >= min_mag)){
										min_passed = 1;
										var url = "pop_up.php?eId=" + last_eId;
										var mWinName = "win_" + last_eId;
										var top = Math.floor((screen.availHeight - s_height) / 2); 
										var left = Math.floor((screen.availWidth - s_width) / 2); 
										var mOption = "width=" + s_width + ",height=" + s_height + ",left=" + left + ",top=" + top;
										win[win_count] = window.open(url, mWinName, mOption);
										win_count++;
									}
								} else {
									if($("#d_past").length){
										server = true;
										$("#store").html("");
									} else {
										if($("#d_sne_connect").length){
											if(sne_connect == 1) server = true;
											sne_connect = 0;
										} else {
											if(sne_connect == 0) server = true;
											sne_connect = 1;
										}
										if($("#d_sne_exec").length){
											if(sne_exec == 1) server = true;
											sne_exec = 0;
										} else {
											if(sne_exec == 0) server = true;
											sne_exec = 1;
										}
									}
									if(server == false){
										try{
											if(!win[win_count - 1] || win[win_count - 1].closed){
												if(level_passed == 0 && min_passed == 0 && (Number($("#d_level").text()) >= min_level || Number($("#d_mag").text()) >= min_mag)){
													if($.cookie('last_opened') && $.cookie('last_opened') == last_eId){
													} else {
														min_passed = 1;
														var url = "pop_up.php?eId=" + last_eId;
														var mWinName = "win_" + last_eId;
														var top = Math.floor((screen.availHeight - s_height) / 2); 
														var left = Math.floor((screen.availWidth - s_width) / 2); 
														var mOption = "width=" + s_width + ",height=" + s_height + ",left=" + left + ",top=" + top;
														win[win_count] = window.open(url, mWinName, mOption);
														win_count++;
													}
												}
											}
										} catch(e) {}
									}
								}
								if(server == false){
									get_dValiable();
								}
							}
						},
						error:function(XMLHttpRequest, textStatus, errorThrown){
							if(textStatus == "timeout"){
								$getdata.abort();
							}
						}
					});
				} else {
					if(end_count >= 1){
						end_count++;
					}
				}
			}
			$("#moni").text("監視中");
			$("#moni").css("color","#000");
			$("#moni").toggle();
			if(err_count >= 5){
				if(!!(document.createElement('audio').canPlayType)){
					err_network.pause();
					err_network.volume = 0;
					err_network.currentTime = 0;
					set_sound(__MP3_DIR + "ok_network.mp3",10);
				}
			}
			err_count = 0;
			setTimeout("log_check()",1000);
		},
		error:function(XMLHttpRequest, textStatus, errorThrown){
			if(textStatus == "timeout"){
				$("#moni").text("タイムアウト");
			} else {
				$("#moni").text("接続エラー");
			}
			$("#moni").css("color","#f00");
			$("#moni").show();
			if(err_count % 10 == 8){
				if(!!(document.createElement('audio').canPlayType)){
					err_network.volume = 1;
					err_network.play();
				}
				$("#warning").text("ネットワークに障害が発生しています");
			}
			if(textStatus == "timeout"){
				$gettime.abort();
			}
//			 else {
				err_count++;
//			}
			setTimeout("log_check()",1000);
		}
	});
}
